<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="版本号" prop="appVersion">
        <el-input v-model="formData.appVersion" placeholder="请输入版本号" />
      </el-form-item>
      <el-form-item label="app名称" prop="appName">
        <el-input v-model="formData.appName" placeholder="请输入包名称" />
      </el-form-item>
      <el-form-item :label="t('fileInfo.appendix')" prop="url">
        <UploadFile v-model="formData.url" :limit="1" :is-show-tip="false" class="min-w-80px" />
      </el-form-item>
      <el-form-item :label="t('iotMaintain.remark')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('iotMaintain.remarkHolder')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotAppApi, IotAppVO } from '@/api/pms/app'

/** app版本更新 表单 */
defineOptions({ name: 'IotAppForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  appVersion: undefined,
  url: undefined,
  remark: undefined,
  appName: undefined,
})
const formRules = reactive({
  appVersion: [{ required: true, message: '版本号不能为空', trigger: 'blur' }],
  appName: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
  url: [{ required: true, message: '附件不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotAppApi.getIotApp(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotAppVO
    if (formType.value === 'create') {
      await IotAppApi.createIotApp(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotAppApi.updateIotApp(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    appVersion: undefined,
    url: undefined,
    remark: undefined,
    appName: undefined,
  }
  formRef.value?.resetFields()
}
</script>
